///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2019, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область ПрограммныйИнтерфейс

// Описывает правил транслитерации национального алфавита в латиницу.
//
// Параметры:
//  Правила- Соответствие - ключ как буква национального алфавита, значение как буква латинского алфавита.
//
Процедура ПриЗаполненииПравилТранслитерации(Правила) Экспорт
	
	// Локализация начало
	
	// АПК:547-выкл
	// АПК:488-выкл
	
	// Следующий фрагмент кода выполняет условный вызов процедуры ПриЗаполненииПравилТранслитерации
	// при наличии модуля СтроковыеФункцииКлиентСерверРФ.
	
	#Если Сервер Или ТолстыйКлиентОбычноеПриложение Или ВнешнееСоединение Тогда
		
		Если Метаданные.ОбщиеМодули.Найти("СтроковыеФункцииКлиентСерверРФ") <> Неопределено Тогда 
			МодульСтроковыеФункцииКлиентСерверРФ = ОбщегоНазначения.ОбщийМодуль("СтроковыеФункцииКлиентСерверРФ");
			МодульСтроковыеФункцииКлиентСерверРФ.ПриЗаполненииПравилТранслитерации(Правила);
		КонецЕсли;
	#Иначе
		МодульСтроковыеФункцииКлиентСерверРФ = Вычислить("СтроковыеФункцииКлиентСерверРФ");
		Если ТипЗнч(МодульСтроковыеФункцииКлиентСерверРФ) = Тип("ОбщийМодуль") Тогда
			МодульСтроковыеФункцииКлиентСерверРФ.ПриЗаполненииПравилТранслитерации(Правила);
		КонецЕсли;
	#КонецЕсли
	// АПК:488-вкл
	// АПК:547-вкл
	
	// Локализация конец
	
КонецПроцедуры

#КонецОбласти