///////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2019, ООО 1С-Софт
// Все права защищены. Эта программа и сопроводительные материалы предоставляются 
// в соответствии с условиями лицензии Attribution 4.0 International (CC BY 4.0)
// Текст лицензии доступен по ссылке:
// https://creativecommons.org/licenses/by/4.0/legalcode
///////////////////////////////////////////////////////////////////////////////////////////////////////

#Область ПрограммныйИнтерфейс

// См. СтандартныеПодсистемыКлиентСерверЛокализация.ПриЗаполненииПравилТранслитерации
//
Процедура ПриЗаполненииПравилТранслитерации(Правила) Экспорт
	
	// Транслитерация, используемая в загранпаспортах 1997-2010.
	Правила.Вставить("а","a");
	Правила.Вставить("б","b");
	Правила.Вставить("в","v");
	Правила.Вставить("г","g");
	Правила.Вставить("д","d");
	Правила.Вставить("е","e");
	Правила.Вставить("ё","e"); // АПК:163 требуется транслитерация.
	Правила.Вставить("ж","zh");
	Правила.Вставить("з","z");
	Правила.Вставить("и","i");
	Правила.Вставить("й","y");
	Правила.Вставить("к","k");
	Правила.Вставить("л","l");
	Правила.Вставить("м","m");
	Правила.Вставить("н","n");
	Правила.Вставить("о","o");
	Правила.Вставить("п","p");
	Правила.Вставить("р","r");
	Правила.Вставить("с","s");
	Правила.Вставить("т","t");
	Правила.Вставить("у","u");
	Правила.Вставить("ф","f");
	Правила.Вставить("х","kh");
	Правила.Вставить("ц","ts");
	Правила.Вставить("ч","ch");
	Правила.Вставить("ш","sh");
	Правила.Вставить("щ","shch");
	Правила.Вставить("ъ",""); // Пропускается.
	Правила.Вставить("ы","y");
	Правила.Вставить("ь",""); // Пропускается.
	Правила.Вставить("э","e");
	Правила.Вставить("ю","yu");
	Правила.Вставить("я","ya");
	
КонецПроцедуры

// Проверяет, содержит ли строка только символы кириллического алфавита.
//
// Параметры:
//  СтрокаПроверки - Строка - проверяемая строка.
//  УчитыватьРазделителиСлов - Булево - учитывать ли разделители слов или они являются исключением.
//  ДопустимыеСимволы - Строка - дополнительные разрешенные символы, кроме кириллицы.
//
// Возвращаемое значение:
//  Булево - Истина, если строка содержит только кириллические (или допустимые) символы или пустая;
//           Ложь, если строка содержит иные символы.
//
Функция ТолькоКириллицаВСтроке(Знач СтрокаПроверки, Знач УчитыватьРазделителиСлов = Истина, ДопустимыеСимволы = "") Экспорт
	
	Если ТипЗнч(СтрокаПроверки) <> Тип("Строка") Тогда
		Возврат Ложь;
	КонецЕсли;
	
	Если НЕ ЗначениеЗаполнено(СтрокаПроверки) Тогда
		Возврат Истина;
	КонецЕсли;
	
	// АПК:163-выкл В данных буква допустима.
	КодыДопустимыхСимволов = Новый Массив;
	КодыДопустимыхСимволов.Добавить(1105); // "ё"
	КодыДопустимыхСимволов.Добавить(1025); // "Ё"
	// АПК:163-вкл
	
	Для Индекс = 1 По СтрДлина(ДопустимыеСимволы) Цикл
		КодыДопустимыхСимволов.Добавить(КодСимвола(Сред(ДопустимыеСимволы, Индекс, 1)));
	КонецЦикла;
	
	Для Индекс = 1 По СтрДлина(СтрокаПроверки) Цикл
		КодСимвола = КодСимвола(Сред(СтрокаПроверки, Индекс, 1));
		Если ((КодСимвола < 1040) Или (КодСимвола > 1103)) 
			И (КодыДопустимыхСимволов.Найти(КодСимвола) = Неопределено) 
			И Не (Не УчитыватьРазделителиСлов И СтроковыеФункцииКлиентСервер.ЭтоРазделительСлов(КодСимвола)) Тогда
			Возврат Ложь;
		КонецЕсли;
	КонецЦикла;
	
	Возврат Истина;
	
КонецФункции

#КонецОбласти